require 'will_paginate/array'
require 'csv'

class Hermes::Admin::HousingRequestsController < Hermes::Admin::BaseController
  before_filter :authorize_users
  before_filter :check_adminrole
  layout "admin"

  def index
    @hrs = Hermes::HousingRequest.readable_by(current_user)
    @year = params[:year].presence || Date.today.year
    @active_hr = Hermes::Accounting.where(target: "request", year: @year).distinct(:object_id).count
    @active_ho = Hermes::Accounting.where(target: "offer", year: @year).distinct(:object_id).count

    @hrs = @hrs.paginate(page:params[:page])
    @total_hr = @hrs.total_entries

    respond_to do |format|
      format.js
      format.html
    end
  end
end
