# frozen_string_literal: true

module Hermes
  class LessorContact
    include Hermes::Concerns::CommonFieldsConcern
    
    field :name, type: String
    field :email, type: String
    field :phone, type: String

    
    belongs_to(
      :lessor,
      class_name: 'Hermes::Lessor',
      index: true
    )
    
    validates_presence_of :name
    owner_field :user_id

    common_indexes *%i[
      name
      email
      phone
    ]
  end
end
