# frozen_string_literal: true

# Array class utilitary methods
class Array
  def inverted_values
    map do |elt|
      if elt.respond_to? :each
        elt.inverted_values
      else
        val * -1
      end
    end
  end

  def unnegate
    map do |elt|
      if elt.respond_to? :each
        elt.unnegate
      else
        val.negative? ? 0 : val
      end
    end
  end

  def all_to(type)
    map do |elt|
      if elt.respond_to? :each
        elt.all_to(type)
      else
        case type&.name
        when 'String'
          elt.to_s rescue nil
        when 'Integer'
          Integer(elt) rescue nil
        when 'Float'
          Float(elt) rescue nil
        else
          elt
        end
      end
    end
  end
end
