# frozen_string_literal: true

module Hermes
  module BoClient
    # extending Mapping Module from base_map.rb
    module Mappings
      # handle HousingRequest model mapping for xml data send
      class FindNudMap
        include Hermes::BoClient::Mappings::Concerns::BaseMap
        def initialize(options)
          housing_request_initializer_id = options[:housing_request_initializer_id]
          self.main_object = Hermes::HousingRequestInitializer.find_by(id: housing_request_initializer_id)
          @unique_number = options[:unique_number]
          @main_object = self.main_object
          @map = {}
        end

        def numUnique
          @unique_number || @main_object.unique_number
        end
=begin

        def civilite
          @housing_request.main_applicant&.civility
        end

        def nom
          @housing_request.requester_lastname
        end

        def prenom
          @housing_request.requester_firstname
        end

        def date_naissance
          @housing_request.requester_birth_date&.to_date
        end

        def commune_souhaitee
          @housing_request.seeked_districts
        end
=end
      end
    end
  end
end
